/*!
 * react-simple-timer v2.2.0
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["react-mic"] = factory(require("react"));
	else
		root["react-mic"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.default = undefined;
	var _jsxFileName = '/Users/markmuskardin/code/javascript/react-simple-timer/src/index.js';

	var _react = __webpack_require__(2);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var ReactSimpleTimer = function (_Component) {
	  _inherits(ReactSimpleTimer, _Component);

	  function ReactSimpleTimer() {
	    _classCallCheck(this, ReactSimpleTimer);

	    var _this = _possibleConstructorReturn(this, _Component.call(this));

	    _this.state = {
	      time: 0,
	      play: false,
	      pause: false,
	      timeType: 0,
	      title: ''
	    };
	    // Bind early, avoid function creation on render loop
	    _this.start = _this.start.bind(_this);
	    _this.stop = _this.stop.bind(_this);
	    _this.elapseTime = _this.elapseTime.bind(_this);
	    return _this;
	  }

	  ReactSimpleTimer.prototype.componentDidMount = function componentDidMount() {
	    if (this.props.play) {
	      this.start();
	    }
	  };

	  ReactSimpleTimer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
	    if (nextProps.pause) {
	      this.pause();
	    } else if (nextProps.play) {
	      this.start();
	    } else {
	      this.stop();
	    }
	  };

	  ReactSimpleTimer.prototype.componentWillUnmount = function componentWillUnmount() {
	    clearInterval(this.interval);
	  };

	  ReactSimpleTimer.prototype.elapseTime = function elapseTime() {
	    if (this.state.play === true) {
	      var newState = this.state.time + 1;
	      this.setState({ time: newState });
	    }
	  };

	  ReactSimpleTimer.prototype.format = function format(seconds) {
	    var m = Math.floor(seconds % 3600 / 60);
	    var s = Math.floor(seconds % 3600 % 60);
	    var timeFormated = (m < 10 ? "0" : "") + m + ":" + (s < 10 ? "0" : "") + s;
	    return timeFormated;
	  };

	  ReactSimpleTimer.prototype.restartInterval = function restartInterval() {
	    clearInterval(this.interval);
	    this.interval = setInterval(this.elapseTime, 1000);
	  };

	  ReactSimpleTimer.prototype.start = function start() {
	    if (true === this.state.play) return;

	    this.restartInterval();

	    this.setState({
	      play: true
	    });
	  };

	  ReactSimpleTimer.prototype.stop = function stop() {
	    var resetFor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.state.time;

	    clearInterval(this.interval);
	    var time = this.format(resetFor);
	    this.setState({ play: false, time: 0 });
	  };

	  ReactSimpleTimer.prototype.pause = function pause() {
	    var time = this.state.time;

	    clearInterval(this.interval);
	    this.setState({ play: false, time: time });
	  };

	  ReactSimpleTimer.prototype.render = function render() {
	    var time = this.state.time;

	    return _react2.default.createElement(
	      'div',
	      { className: 'display timer', __source: {
	          fileName: _jsxFileName,
	          lineNumber: 83
	        },
	        __self: this
	      },
	      _react2.default.createElement(
	        'span',
	        { className: 'time', __source: {
	            fileName: _jsxFileName,
	            lineNumber: 84
	          },
	          __self: this
	        },
	        this.format(time)
	      )
	    );
	  };

	  return ReactSimpleTimer;
	}(_react.Component);

	exports.default = ReactSimpleTimer;
	;

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ }
/******/ ])
});
;